#include <gtk/gtk.h>
#include "interface.h"
#include "smscompose.h"
#include "support.h"
#include "pdu.h"


void
smscompose_send(GtkButton * button, GtkWidget *w)
{
	GtkWidget *smsnumber, *smstext;
	GtkTextBuffer *content;
	GtkTextIter start, end;
	gchar *text;
	const gchar *number;
	struct pdu *pdu;
	gchar *sms_pdu;

	smsnumber=lookup_widget(w, "smsnumber");
	smstext=lookup_widget(w, "smstext");
	content=gtk_text_view_get_buffer(GTK_TEXT_VIEW(smstext));
	gtk_text_buffer_get_iter_at_offset(content, &start, 0);
	gtk_text_buffer_get_iter_at_offset(content, &end, -1);
	text=gtk_text_buffer_get_text(content, &start, &end, FALSE);
	number= gtk_combo_box_get_active_text(GTK_COMBO_BOX(smsnumber));
	
	printf("Sending '%s' to '%s'\n", text, number);
	pdu=pdu_new(number,NULL,text);
	sms_pdu=pdu_encode(pdu);
	printf("pdu='%s'\n", sms_pdu);
	db_sms_new("Sent",sms_pdu);
	sendSMS(sms_pdu);

	g_free(sms_pdu);
	pdu_free(pdu);
	g_free(text);
}

void
smscompose_draft(GtkButton * button, GtkWidget *w)
{
}

void
smscompose_template(GtkButton * button, GtkWidget *w)
{
}

void
smscompose_cancel(GtkButton * button, GtkWidget *w)
{
}


void signal_connect_clicked(GtkWidget *w, char *button, void (*func)(GtkButton *, GtkWidget *))
{
	GtkWidget *b;

	b=lookup_widget(w, button);
	g_signal_connect(b, "clicked", (GCallback) func, w);
}

void
smscompose_open(char *number)
{
	GtkWidget *compose_widget,*smsnumber;

	compose_widget=create_SMSCompose();
	
	smsnumber=lookup_widget(compose_widget, "smsnumber");
	if (number)
		gtk_combo_box_append_text(GTK_COMBO_BOX(smsnumber),number);
	signal_connect_clicked(compose_widget,"send",smscompose_send);
	signal_connect_clicked(compose_widget,"draft",smscompose_draft);
	signal_connect_clicked(compose_widget,"template",smscompose_template);
	signal_connect_clicked(compose_widget,"cancel",smscompose_cancel);
	gtk_widget_show(compose_widget);

}
